{x$H-}
{$DEFINE INDONESIAN}
UNIT RSTR;
INTERFACE
USES DOS;
CONST DATEFORMAT=0;
TYPE RDATE=RECORD YEAR,MONTH,DAY:WORD;END;

              FUNCTION CUTSL(X:STRING;L:INTEGER):STRING;
              FUNCTION UPPERCASE(X:STRING):STRING;
              FUNCTION CUTS(X:STRING;L:INTEGER):STRING;
              FUNCTION CURRTOSTR(X:REAL;L:LONGINT):STRING;
              FUNCTION REALTOSTR(X:REAL;L,D:LONGINT):STRING;
              FUNCTION LONGINTTOSTR(X,L:LONGINT):STRING;
              FUNCTION DATETOSTR(X:RDATE):STRING;
              PROCEDURE GETCURRDATE(VAR D:RDATE);
              FUNCTION STRTOLONGINT(X:STRING):LONGINT;
              FUNCTION STRTOREAL(X:STRING):REAL;
              PROCEDURE STRTODATE(X:STRING;VAR DT:RDATE);
              FUNCTION PLONGINTTOSTR(X:LONGINT):STRING;
              FUNCTION PREALTOSTR(X:REAL):STRING;
IMPLEMENTATION

              FUNCTION LONGINTTOSTR(X,L:LONGINT):STRING;
              VAR TMP:STRING[100];
              BEGIN
                   STR(X:L,TMP);
                   LONGINTTOSTR:=TMP;
              END;
              FUNCTION PLONGINTTOSTR(X:LONGINT):STRING;
              VAR TMP:STRING[100];
              BEGIN
                   STR(X,TMP);
                   PLONGINTTOSTR:=TMP;
              END;

              FUNCTION PREALTOSTR(X:REAL):STRING;
              VAR TMP:STRING[100];
              BEGIN
                   STR(X,TMP);
                   PREALTOSTR:=TMP;
              END;
              FUNCTION REALTOSTR(X:REAL;L,D:LONGINT):STRING;
              VAR TMP:STRING[100];
              BEGIN
                   STR(X:L:D,TMP);
                   REALTOSTR:=TMP;
              END;

              FUNCTION CURRTOSTR(X:REAL;L:LONGINT):STRING;
              VAR TMP,RES:STRING[100];
                  T,D:INTEGER;
              BEGIN
                   IF X=0 THEN BEGIN
                      CURRTOSTR:='';
                      EXIT;
                   END;
                   STR(X:L:2,TMP);
                   L:=LENGTH(TMP);
                   D:=0;
                   {$IFDEF INDONESIAN}
                   RES:=','+COPY(TMP,L-1,2);
                   {$ELSE}
                   RES:='.'+COPY(TMP,L-1,2);
                   {$ENDIF}
                   FOR T:=L-3 DOWNTO 1 DO BEGIN
                       CASE TMP[T-1] OF
                            ' ':D:=-20;
                       END;

                       RES:=TMP[T]+RES;
                       INC(D);
                       IF D=3 THEN
                       BEGIN
                   {$IFDEF INDONESIAN}
                            RES:='.'+RES;
                   {$ELSE}
                            RES:=','+RES;
                   {$ENDIF}
                            D:=0;
                       END;
                   END;

                   {$IFDEF INDONESIAN}
                   CURRTOSTR:='Rp'+CUTSL(RES,L-2);
                   {$ELSE}
                   CURRTOSTR:='$'+CUTSL(RES,L-1);
                   {$ENDIF}
              END;


              FUNCTION DATETOSTR(X:RDATE):STRING;
              VAR A,B,C:STRING[4];
              BEGIN
                   STR(X.MONTH:2,A);
                   STR(X.DAY:2,B);
                   STR(X.YEAR:4,C);
                   IF A[1]=' ' THEN A[1]:='0';
                   IF B[1]=' ' THEN B[1]:='0';
                   IF C[1]=' ' THEN C[1]:='0';
                   IF C[2]=' ' THEN C[2]:='0';
                   IF C[3]=' ' THEN C[3]:='0';

                   {$IFDEF INDONESIAN}
                   DATETOSTR:=B+'-'+A+'-'+C;
                   {$ELSE}
                   DATETOSTR:=A+'/'+B+'/'+C;
                   {$ENDIF}
              END;


              PROCEDURE GETCURRDATE(VAR D:RDATE);
              VAR C:WORD;
              BEGIN
                   GETDATE(D.YEAR,D.MONTH,D.DAY,C);
              END;

              FUNCTION STRTOREAL(X:STRING):REAL;
              VAR E:INTEGER;
                  A:REAL;
              BEGIN
                   VAL(X,A,E);
                   STRTOREAL:=A;
              END;

              FUNCTION STRTOLONGINT(X:STRING):LONGINT;
              VAR E:INTEGER;
                  A:LONGINT;
              BEGIN
                   VAL(X,A,E);
                   STRTOLONGINT:=A;
              END;

              PROCEDURE STRTODATE(X:STRING;VAR DT:RDATE);
              VAR D,M,Y:WORD;
              BEGIN
                   {$IFDEF INDONESIAN}
                    D:=STRTOLONGINT(COPY(X,1,POS('-',X)-1));
                    X:=COPY(X,POS('-',X)+1,15);
                    M:=STRTOLONGINT(COPY(X,1,POS('-',X)-1));
                    X:=COPY(X,POS('-',X)+1,15);
                    Y:=STRTOLONGINT(X);
                   {$ELSE}
                    M:=STRTOLONGINT(COPY(X,1,POS('/',X)-1));
                    X:=COPY(X,POS('/',X)+1,15);
                    D:=STRTOLONGINT(COPY(X,1,POS('/',X)-1));
                    X:=COPY(X,POS('/',X)+1,15);
                    Y:=STRTOLONGINT(X);
                   {$ENDIF}
                   DT.YEAR:=Y;
                   DT.MONTH:=M;
                   DT.DAY:=D;

              END;

              FUNCTION CUTS(X:STRING;L:INTEGER):STRING;
              BEGIN
                   IF LENGTH(X)>L THEN CUTS:=COPY(X,1,L) ELSE
                                       CUTS:=X;
              END;
              FUNCTION CUTSL(X:STRING;L:INTEGER):STRING;
              BEGIN
                   IF LENGTH(X)>L THEN CUTSL:=COPY(X,LENGTH(X)-L+1,L) ELSE
                                       CUTSL:=X;
              END;

              FUNCTION UPPERCASE(X:STRING):STRING;
              VAR A:STRING[100] ABSOLUTE X;
                  T:INTEGER;
              BEGIN
                   FOR T:=1 TO LENGTH(A) DO A[T]:=UPCASE(A[T]);
                   UPPERCASE:=A;
              END;

END.